# we set some options for the tk-widgets

proc database_options {{nspace ::}} \
{
  upvar ${nspace}::CONFIG CONFIG
 
  # we check the tcl version (at the moment for the look of the checkbuttons
  # because the it was changed with version 8.5)
  if {[info tclversion] > 8.4} \
  {
    set Tcl84 0
  } else \
  {
    set Tcl84 1
  }

  option add *Font {Helvetia -12 normal}
 
  if {![info exists CONFIG(Color)]} {set CONFIG(Color) "blue"}
 
  switch -- $CONFIG(Color) \
  {
    "blue"       { set BackgroundColor #d6eeff
                  set BackgroundColor2 #c3e4ff
                  set HighligthColor "blue"
                 } \
    "sandyellow" { set BackgroundColor #FFFFE3
                  set BackgroundColor2 #FFFFC0
                  set HighligthColor #e66600
                 } \
    default      { set BackgroundColor #FFFFE3
                   set BackgroundColor2 #FFFFC0
                   set HighligthColor #e66600
                 } \
  }
 
 
  tk_setPalette $BackgroundColor
 
  option add *background $BackgroundColor
 
  option add *Entry.background white
  option add *Entry.disabledBackground $BackgroundColor
   
  option add *Button.relief groove
  option add *Button.activeBackground $BackgroundColor2
 
  option add *Scrollbar.activeBackground $BackgroundColor2
  option add *Scrollbar.troughColor $BackgroundColor
 
  option add *Menu.activeBackground $BackgroundColor2
  
  option add *Checkbutton.activeBackground $BackgroundColor2
  #option add *Radiobutton.activeBackground $BackgroundColor2
  
  option add *Menubutton.activeBackground $BackgroundColor2 
  
  if {$Tcl84} \
  {
    option add *Checkbutton.selectColor $HighligthColor
    option add *Radiobutton.selectColor $HighligthColor
  } else \
  {
    option add *Checkbutton.selectColor white
    option add *Radiobutton.selectColor white
  }
}

