#
#---this looks for text pattern in all files of a directory (and its subdirectories)

proc ::tk_edit::SearchInFiles {} \
{
 variable VAR; variable CONFIG
 
 # first we load the needed packages
 ::tk_edit::Packageload [list FR_search FR_dirBox]
 
 # now we create the GUI
 set VAR(SifToplevel) sif
 
 if {[winfo exists .$VAR(SifToplevel)]} {destroy .$VAR(SifToplevel)}
 
 toplevel .$VAR(SifToplevel)
 wm title .$VAR(SifToplevel) [msgcat::mc "Search in files"]
 wm protocol .$VAR(SifToplevel) WM_DELETE_WINDOW {::tk_edit::SifExit}
 wm withdraw .$VAR(SifToplevel)
 
 ::tk_edit::SifGUI
 
 # we fill out the presettings
 ::tk_edit::SifFirstStart
 
 ::FR_general::CenterWindow .$VAR(SifToplevel) $VAR(Parent) 0
 wm deiconify .$VAR(SifToplevel)

 return 0
}


#---we create all widgets
proc ::tk_edit::SifGUI {} \
{
 variable VAR
 
 # we create all frames
 frame .$VAR(SifToplevel).frame1 -relief flat
 labelframe .$VAR(SifToplevel).frame2 -relief groove -text [msgcat::mc "Search options"] -foreground blue
 frame .$VAR(SifToplevel).frame3 -relief flat
 frame .$VAR(SifToplevel).frame4 -relief flat
 
 pack  .$VAR(SifToplevel).frame1 -side top -fill x -padx 5 -pady 5
 pack  .$VAR(SifToplevel).frame2 -side top -fill x -padx 5 -pady 5
 pack  .$VAR(SifToplevel).frame3 -side top -fill x -padx 5 -pady 10
 pack  .$VAR(SifToplevel).frame4 -side top -fill both -expand yes -padx 5 -pady 5

 set VAR(SifSearchFrame) "$VAR(SifToplevel).frame1"
 set VAR(SifOptionsFrame) "$VAR(SifToplevel).frame2"
 set VAR(SifBottomFrame) "$VAR(SifToplevel).frame3"
 set VAR(SifResultFrame) "$VAR(SifToplevel).frame4"

 # the selection of the directory
 label .$VAR(SifSearchFrame).dirlabel -text [msgcat::mc "Directory:"]
 entry .$VAR(SifSearchFrame).direntry -width 35 -background white -xscrollcommand ".$VAR(SifSearchFrame).xsbar set"
 scrollbar .$VAR(SifSearchFrame).xsbar -orient horizontal -command ".$VAR(SifSearchFrame).direntry xview"
 button .$VAR(SifSearchFrame).button -text [msgcat::mc "Open"] -state normal -command {::tk_edit::SifDirSel}

 grid .$VAR(SifSearchFrame).dirlabel -row 0 -column 0 -sticky w -padx {5 0} -pady {5 0}
 grid .$VAR(SifSearchFrame).direntry -row 0 -column 1 -sticky ew -padx 5 -pady {5 0}
 grid .$VAR(SifSearchFrame).xsbar -row 1 -column 1 -sticky ew -padx 5 -pady {0 5}
 grid .$VAR(SifSearchFrame).button -row 0 -column 2 -rowspan 2 -sticky nsew -padx {0 5} -pady 5
 
 # the search field
 label .$VAR(SifSearchFrame).searchlabel -text [msgcat::mc "Search for:"]
 entry .$VAR(SifSearchFrame).searchentry -background white
 
 grid .$VAR(SifSearchFrame).searchlabel -row 2 -column 0 -sticky w -padx {5 0} -pady 5
 grid .$VAR(SifSearchFrame).searchentry -row 2 -column 1 -columnspan 2 -sticky ew -padx 5 -pady 5
 grid columnconfigure .$VAR(SifSearchFrame) 1 -weight 1
 grid rowconfigure .$VAR(SifSearchFrame) 0 -weight 1
 
 bind .$VAR(SifSearchFrame).searchentry <Control-v> {::tk_edit::SifEntryPast}
 
 # the options
 checkbutton .$VAR(SifOptionsFrame).casesens -text [msgcat::mc "Case sensitive search"] -justify left -onvalue 1 -offvalue 0 -variable ::tk_edit::CONFIG(SifCaseSens)
 checkbutton .$VAR(SifOptionsFrame).hiddendir -text [msgcat::mc "Include also hidden directories"] -justify left -onvalue 1 -offvalue 0 -variable ::tk_edit::CONFIG(SifHiddenDirs)
 checkbutton .$VAR(SifOptionsFrame).hiddenfiles -text [msgcat::mc "Include also hidden files"] -justify left -onvalue 1 -offvalue 0 -variable ::tk_edit::CONFIG(SifHiddenFiles)
 checkbutton .$VAR(SifOptionsFrame).onlytcl -text [msgcat::mc "Look only in files with the extension tcl"] -justify left -onvalue 1 -offvalue 0 -variable ::tk_edit::CONFIG(SifOnlyTclFiles)
 
 grid .$VAR(SifOptionsFrame).casesens -row 0 -column 0 -sticky w -padx 5 -pady {5 0}
 grid .$VAR(SifOptionsFrame).hiddendir -row 1 -column 0 -sticky w -padx 5 -pady {5 0}
 grid .$VAR(SifOptionsFrame).hiddenfiles -row 2 -column 0 -sticky w -padx 5 -pady {5 0}
 grid .$VAR(SifOptionsFrame).onlytcl -row 3 -column 0 -sticky w -padx 5 -pady 5
 grid columnconfigure .$VAR(SifOptionsFrame) 1 -weight 1
 
 # the search / cancel buttons
 set ButtonText [::FR_general::ButtonsWithSameWidth [list [msgcat::mc "Search"] [msgcat::mc "Close"]]]

 button .$VAR(SifBottomFrame).cancel -text [lindex $ButtonText 1] -state normal -width [lindex $ButtonText 2] -command {::tk_edit::SifExit}
 button .$VAR(SifBottomFrame).search -text [lindex $ButtonText 0] -state normal -width [lindex $ButtonText 2] -command {::tk_edit::SifSearchPrepare}
         
 pack .$VAR(SifBottomFrame).search -side left -padx {5 0} -pady 5 -expand yes -fill x
 pack .$VAR(SifBottomFrame).cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
 bind .$VAR(SifToplevel) <KeyPress-Escape> [list .$VAR(SifBottomFrame).cancel invoke]
 bind .$VAR(SifToplevel) <KeyPress-Return> [list .$VAR(SifBottomFrame).search invoke]
 
 # the result window
 text .$VAR(SifResultFrame).output -height 12 -wrap word -background white -state disable -cursor top_left_arrow -xscrollcommand ".$VAR(SifResultFrame).xsbar set" -yscrollcommand ".$VAR(SifResultFrame).ysbar set"
 scrollbar .$VAR(SifResultFrame).xsbar -orient horizontal -command ".$VAR(SifResultFrame).output xview"
 scrollbar .$VAR(SifResultFrame).ysbar -orient vertical -command ".$VAR(SifResultFrame).output yview"

 grid .$VAR(SifResultFrame).output .$VAR(SifResultFrame).ysbar -sticky nsew
 grid .$VAR(SifResultFrame).xsbar -sticky nsew
 grid columnconfigure .$VAR(SifResultFrame) 0 -weight 1
 grid rowconfigure .$VAR(SifResultFrame) 0 -weight 1
 
 # we configure the text tags
 .$VAR(SifResultFrame).output tag configure "file_error" -foreground red -lmargin1 0.1i
 .$VAR(SifResultFrame).output tag configure "body" -foreground black -lmargin1 0.2i
}


#---the exit proc for the search in files dialog
proc ::tk_edit::SifExit {} \
{
 variable VAR
 
 focus $VAR(Parent)
 destroy .$VAR(SifToplevel)
 
 #::tk_edit::SetCursor .$VAR(TextFrame) $VAR(InsertPosition) 0
 
 return 0
}


#---the startup
proc ::tk_edit::SifFirstStart {} \
{
 variable VAR; variable CONFIG

 .$VAR(SifSearchFrame).searchentry insert end $VAR(Search)
 .$VAR(SifSearchFrame).direntry insert end $CONFIG(SifDirectroy)
 
 set VAR(SifTagList) ""
}


#---the directory selection
proc ::tk_edit::SifDirSel {} \
{
 variable VAR; variable CONFIG
  
 # we start the dir select dialog
 if {$CONFIG(SifHiddenDirs)} \
 {
  set NewDir [::FR_dirBox::Create -initialdir $CONFIG(SifDirectroy) -view_hidden_dirs 1 -parent .$VAR(SifToplevel)]
 } else \
 {
  set NewDir [::FR_dirBox::Create -initialdir $CONFIG(SifDirectroy) -view_hidden_dirs 0 -parent .$VAR(SifToplevel)]
 }
 
 if {$NewDir eq ""} {return 1}
 
 # we insert the new path to the entry box
 .$VAR(SifSearchFrame).direntry delete 0 end
 .$VAR(SifSearchFrame).direntry insert end $NewDir
 
 # we save the new configuration
 set CONFIG(SifDirectroy) $NewDir
 
 return 0
}


#---we prepare the searching
proc ::tk_edit::SifSearchPrepare {} \
{
 variable VAR; variable CONFIG
 
 set Dir [file normalize [.$VAR(SifSearchFrame).direntry get]]
 
 # we check the directories again because the entries could put in per hand with errors
 if {![file isdirectory $Dir]} \
 {
  ::FR_messageBox::Create -type "Error" -title [msgcat::mc "An error occured!"] -message [msgcat::mc "This isn't a directory: %s" $Dir]
  return 1
 }
 
 set CONFIG(SifDirectroy) $Dir
 
 # we fetch the search pattern and if it's empty we return
 set Pattern [.$VAR(SifSearchFrame).searchentry get]
 
 if {$Pattern eq ""} {return 1}
 
 # we set the wished file type
 if {$CONFIG(SifOnlyTclFiles)} \
 {
  set VAR(SifFileType) "*.tcl"
 } else \
 {
  set VAR(SifFileType) "*"
 }
 
 ::tk_edit::SifSearch $Pattern
}


#---we start the search
proc ::tk_edit::SifSearch {Pattern} \
{
 variable VAR; variable CONFIG
 
 ::FR_search::Create -startdir $CONFIG(SifDirectroy) -pattern $Pattern -filetype $VAR(SifFileType) -case $CONFIG(SifCaseSens) -hiddendir $CONFIG(SifHiddenDirs) -hiddenfile $CONFIG(SifHiddenFiles)

 .$VAR(SifResultFrame).output configure -state normal
 
 # first we delete the last/old output
 .$VAR(SifResultFrame).output delete 1.0 end
 # and remove all old tags/bindings
 if {$VAR(SifTagList) ne ""} \
 {
   eval .$VAR(SifResultFrame).output tag delete $VAR(SifTagList)
 }
          
 set SearchListLength [llength $::FR_search::VAR(SearchList)]
 if {$SearchListLength < 3} \
 {
   .$VAR(SifResultFrame).output insert end [msgcat::mc "Sorry, nothing found.\n"] file_error   
   .$VAR(SifResultFrame).output configure -state disable
   
   return 1
 }
 
 for {set i 0} {$i < $SearchListLength} {incr i 3} \
 {
  if {[lindex $::FR_search::VAR(SearchList) [expr {$i+1}]] == 0} \
  {
   ::tk_edit::SifShowError $i
  } else \
  {
   ::tk_edit::SifShowResults $i
  }
 }
 
 .$VAR(SifResultFrame).output configure -state disable
}


#---we show the result with a link to the file which contains the pattern
proc ::tk_edit::SifShowResults {Index} \
{
 variable VAR
 
 # we create the tag
 set Tag ""
 append Tag "link" "_" "$Index"
 .$VAR(SifResultFrame).output tag configure $Tag -foreground blue -underline no -lmargin1 0.1i
 .$VAR(SifResultFrame).output tag bind $Tag <Enter> [list .$VAR(SifResultFrame).output tag configure $Tag -underline yes]
 .$VAR(SifResultFrame).output tag bind $Tag <Leave> [list .$VAR(SifResultFrame).output tag configure $Tag -underline no]
 .$VAR(SifResultFrame).output tag bind $Tag <ButtonPress> [list ::tk_edit::SifOpenFile $Index]
 
 # this is the file as link
 .$VAR(SifResultFrame).output insert end [lindex $::FR_search::VAR(SearchList) $Index] $Tag
 .$VAR(SifResultFrame).output insert end "\n"
 # this is the contain of the line with the found pattern
 .$VAR(SifResultFrame).output insert end [lindex $::FR_search::VAR(SearchList) [expr {$Index+2}]] body
 .$VAR(SifResultFrame).output insert end "\n\n"
 
 append VAR(SifTagList) $Tag
}


#---if we couldn't open the file we show an error message
proc ::tk_edit::SifShowError {Index} \
{
 variable VAR
 
 .$VAR(SifResultFrame).output insert end [lindex $::FR_search::VAR(SearchList) $Index] file_error
 .$VAR(SifResultFrame).output insert end "\n"
 .$VAR(SifResultFrame).output insert end [msgcat::mc "We couldn't open this file, the reason for this was:\n"] body
 .$VAR(SifResultFrame).output insert end [lindex $::FR_search::VAR(SearchList) [expr {$Index+2}]] body
 .$VAR(SifResultFrame).output insert end "\n\n"
}


#---if anyone press on the file link - this opens the file (and show the position of the pattern in tk_edit.tcl)
proc ::tk_edit::SifOpenFile {Index} \
{
 set File [lindex $::FR_search::VAR(SearchList) $Index]
 set Pos [lindex $::FR_search::VAR(SearchList) [expr {$Index+1}]]
 append Pos ".0"
 
 ::tk_edit::OpenFileSub $File $Pos 1
}


#---delete the selected text first before past
proc ::tk_edit::SifEntryPast {} \
{
 variable VAR

 if {[.$VAR(SifSearchFrame).searchentry selection present]} \
 {
   .$VAR(SifSearchFrame).searchentry delete sel.first sel.last
 }
}